from ex1 import concat, reversed, drop, factorial, get_item, hd, head, last, length, nth, take


def test_factorial() -> None:
    expected = 24
    actual = factorial(4)
    assert expected == actual


def test_length() -> None:
    expected = 4
    actual = length([10, 21, 32, 43])
    assert expected == actual


def test_hd() -> None:
    expected = 10
    actual = hd([10, 21, 32, 43])
    assert expected == actual


def test_head() -> None:
    expected = 10
    actual = head([10, 21, 32, 43])
    assert expected == actual


def test_get_item() -> None:
    expected: tuple[int, list[int]] = (10, [21, 32, 43])
    actual = get_item([10, 21, 32, 43])
    assert actual is not None
    assert expected == actual


def test_last() -> None:
    expected = 43
    actual = last([10, 21, 32, 43])
    assert expected == actual


def test_nth() -> None:
    expected = 32
    actual = nth([10, 21, 32, 43], 2)
    assert expected == actual


def test_take() -> None:
    expected = [10, 21]
    actual = take([10, 21, 32, 43], 2)
    assert expected == actual


def test_drop() -> None:
    expected = [32, 43]
    actual = drop([10, 21, 32, 43], 2)
    assert expected == actual


def test_reversed() -> None:
    expected = [43, 32, 21, 10]
    actual = reversed([10, 21, 32, 43])
    assert expected == actual


def test_concat() -> None:
    expected = [1, 2, 3, 4, 5, 6]
    actual = concat([[1, 2], [], [3, 4, 5], [6]])
    assert expected == actual
