from ex2 import exists, find, forall, map, filter, tabulate


def succ(x: int) -> int:
    return x + 1


def test_map() -> None:
    expected: list[int] = [12, 22, 32, 44]
    actual: list[int] = map(succ, [11, 21, 31, 43])
    assert expected == actual


def is_even(x: int) -> bool:
    return x % 2 == 0


def test_find_none() -> None:
    expected: int | None = None
    actual: int | None = find(is_even, [11, 21, 31, 43])
    assert expected == actual


def test_find_some() -> None:
    expected: int | None = 32
    actual: int | None = find(is_even, [11, 21, 32, 43])
    assert expected == actual


def test_filter() -> None:
    expected: list[int] = [32]
    actual: list[int] = filter(is_even, [11, 21, 32, 43])
    assert expected == actual


def test_exists() -> None:
    expected: bool = True
    actual: bool = exists(is_even, [11, 21, 32, 43])
    assert expected == actual


def test_forall() -> None:
    expected: bool = False
    actual: bool = forall(is_even, [11, 21, 32, 43])
    assert expected == actual


def test_tabulate() -> None:
    expected: list[int] = [1, 2, 3, 4, 5]
    actual: list[int] = tabulate(5, succ)
    assert expected == actual
